#!/usr/bin/perl
###########################################################################
#                                                                         #
#   Classifieds.pl - Perl Script fuer das Schalten von Kleinanzeigen      #
#                                                                         #
#         Geschrieben von Greg Mathews - greg@notts.net                   #
#                                                                         #
#    Deutsche Uebersetzung Gerold Bigorajski - Bigorajski@T-Online.de     #
#                                                                         #
###########################################################################

# Bibliothek fuer gemeinsam genutzte Funktionen. Evt. absoluter Serverpfad noetig.
require "./class_ad_lib.pl";

# Einlesen der Daten und MIME-Dekodierung
&UnWeb;

# Von wem stammt die Anzeige:
$return_name=$in{'return'}; 
$mailprog=$in{'mailprog'};

# Zeilenumbrche in der Beschreibung ersetzen
$in{'Description'} =~ s/&&/<br><br>/g;
$AdNumber = 0;

# Deutsches Datum fuer die Eingabe
$Jetztwert = time();
$Jetztzeit = localtime($Jetztwert);
&Deutschnamen; # in der Bibliothek
@Zeit = split(/ +/,$Jetztzeit);
($sekunde,$minute,$stunde,$tag,$monat,$jahr,$wochentag,$tagimjahr,$isdst) = localtime(time);
$monat++;
if ($tag < 10) { $tag = "0$tag";}
if ($monat < 10)  { $monat = "0$monat";}
$jahr += 1900;
$date = "$Zeit[0], $Zeit[2]. $Zeit[1] $Zeit[4]";
$shortdate = "$tag.$monat.$jahr";

if ($in{'Selection'} eq "Anzeigen anschauen")
{
	if ($in{'Department'} eq "")
	{
		# Der Benutzer hat keine zu betrachtende Kategorie angegeben. Ergo Fehlermeldung und Abbruch.
		&PrintHeader;
		print "<title>Fehlermeldung</title>\n";
		print "</head>\n";
		print "$bodytag";
		print "\n";
		print "<h2>Es ist ein Fehler aufgetreten:</h2><p>\n";
		print "Sie haben keine Kategorie ausgewhlt, in der Sie Kleinanzeigen anschauen mchten.  Bitte whlen Sie eine, indem Sie auf den Knopf neben der entsprechenden Kategorie drcken.<p>\n";
		print "$separatimg";
		print "<hr><p><center><a href=$in{'ErrorReturn'}>Zurck zum Formular</a><p><p><p>\n";
		&PrintFooter;
		
		# Nun wird das Skript beendet, da es einen Fehler gab.
		exit;
	}
	# Umleitung zu der entsprechenden Kategorie.
	print "Location: $in{'ViewDir'}$in{'Department'}.htm\n\n";
	exit;
}

# Abfrage leerer Felder - im Prinzip ueberfluessig, da bereits durch Javascript in der HTML-Datei abgefangen.
if (($in{'RealName'} eq "") || ($in{'EMailAddress'} eq "") || ($in{'Address1'} eq "") || ($in{'City'} eq "") || ($in{'ZipCode'} eq "")
	|| ($in{'Phone'} eq "") || ($in{'Department'} eq "") || ($in{'Description'} eq ""))
{
	# Irgendetwas wurde nicht ausgefuellt - Fehlermeldung
	&PrintHeader;
	print "<title>Fehlermeldung</title>\n";
	print "</head>\n";
	print "$bodytag";
	print "\n";
	print "<h2>Es ist ein Fehler aufgetreten:</h2><p>\n";
	print "Ein Feld wurde nicht ausgefllt. Es mssen alles Felder vollstndig ausgefllt werden, bevor die Anzeige gespeichert werden kann.<p>\n";
	print "$separatimg";
	print "<p><center><a href=javascript:history.back()>Zurck zum Formular</a><p>\n";
	print "Sollte dieser Link nicht funktionieren, klicken Sie bitte auf <i>ZURCK</i> in Ihrem Browser.\n";
	&PrintFooter;
		
	# Nun wird das Skript beendet, da es einen Fehler gab.
	exit;
}

# Die Datei wird gesperrt, damit sie nicht beschdigt wird, wenn mehr als ein Nutzer gleichzeitig darauf zugreift.
print "Content-type: text/html\n\n";
		
$quit = 0;
while ($quit != 1)
{
	if (-e "$in{'ClassifiedsDir'}.$in{'Department'}lock")
	{
		# Die Lock-Datei existiert - 1 Sekunde warten ...
		sleep(1);
	}
	else
	{
		# Erzeugen der Lock-Datei und damit Sperren der Kleinanzeigen-Datei.
		open (LOCK,">$in{'ClassifiedsDir'}.$in{'Department'}lock");
		close LOCK;
	}
	
	# Oeffnen der Datendatei, um die Nummer der letzten Anzeige zu lesen.
	open (ADFILE, "$in{'ClassifiedsDir'}AdNumber.dta");
	$AdNumber = <ADFILE>;
	# chop $AdNumber;

	# Nummer der Anzeige um eins erhoehen.
	$AdNumber = $AdNumber + 1;
	
	# Zurueckschreiben der Datendatei.
	open (ADFILE, ">$in{'ClassifiedsDir'}AdNumber.dta");
	print ADFILE $AdNumber;
	close(ADFILE);

	# Anhaengen der Anzeige des Benutzers an die Anzeigendatei
	open(ADFILE,"$in{'ClassifiedsDir'}$in{'Department'}.htm") || die $!;
	@main = <ADFILE>;
	close(ADFILE);

	open(ADFILE,">$in{'ClassifiedsDir'}$in{'Department'}.htm") || die $!;
	# Zeilenweises lesen
	foreach $main_line (@main)
	{
		if ($main_line =~ /<!--Do not edit past this line-->/)
		{
			print ADFILE "<!--Do not edit past this line-->\n";
			print ADFILE "<!-- |$AdNumber|$in{'RealName'}|$in{'E-MailAddress'}|$shortdate| -->\n";
			print ADFILE "<b>Anzeige Nr.: </b>$AdNumber - <b>Betrifft: </b>$in{'AdSubject'} - <b>Geschaltet am: </b>$shortdate<br>\n";
			print ADFILE "<b>Antwort an: </b>$in{'RealName'} unter <a href=\"mailto:$in{'EMailAddress'}\">$in{'EMailAddress'}</a><br>\n";
			print ADFILE "$in{'Description'}<p>\n";
			print ADFILE "<b>Homepage: </b><A href=\"$in{'Linkurl'}\">$in{'Linktitle'}</a><p>\n";
			print ADFILE "$separatimg<p>\n";
			print ADFILE "<!-- end $AdNumber -->\n";
		}
	      else
		{
			print ADFILE "$main_line";
		}
	}

	# Anhaengen der persoenlichen Daten des Benutzers an die Datendatei
	open (DATAFILE,">>$in{'ClassifiedsDir'}UserDataFile.htm");
	print DATAFILE "<!-- |$AdNumber|$in{'Department'}|$in{'EMailAddress'}|$shortdate| -->\n";
	print DATAFILE "<b>$in{'RealName'} - <a href=mailto:$in{'EMailAddress'}>$in{'EMailAddress'}</a><br>\n";
	print DATAFILE "$in{'Address1'}<br>\n";
	if ($in{'Address2'} ne "")
	{
		print DATAFILE "$in{'Address2'}<br>\n";
	}
	print DATAFILE "$in{'ZipCode'} $in{'City'}";
	if ($in{'State'} ne "")
	{
		print DATAFILE "$in{'State'}<br>";
	}
	print DATAFILE " - $in{'Phone'}</b><br>\n";
	print DATAFILE "<b>Anz.-Nr.: </b>$AdNumber - <b>Kategorie: </b>$in{'Department'} am: $shortdate<br>\n";
	if ($in{'DesiredDepartment'} ne "")
	{
		print DATAFILE "<b>Wunschkategorie: </b>$in{'DesiredDepartment'}<br>\n";
	}
	print DATAFILE "<b>Beschreibung: </b>$in{'Description'}\n";
	print DATAFILE "<b>Homepage: </b><A href=\"$in{'Linkurl'}\">$in{'Linktitle'}</a><p>\n";
	print DATAFILE "$separatimg<p>\n";
	print DATAFILE "<!-- end $AdNumber -->\n";
	close(DATAFILE);
	
	# Entsperren der Lock-Datei
	unlink("$in{'ClassifiedsDir'}.$in{'Department'}lock");
	
	open( MAIL, "|$mailprog $in{'EMailAddress'}" ) || die "Kann Sendmail nicht oeffnen: $email: $!\n";
	print MAIL "To: $in{'EMailAddress'}\n";
	print MAIL "Subject: Kleinanzeigen-Response\n";	
	print MAIL "From: $return_name\n";
	print MAIL "Reply-to: $return_name\n\n";

	print MAIL "   Danke fr Ihren Eintrag in unsere Internet-Kleinanzeigenbrse.\n";
	print MAIL "   Ihre Anzeige in der Kategorie \"$in{'Department'}\" sieht:\n";
	print MAIL "   folgendermaen aus:\n";

	print MAIL "Anzeige Nr.: $AdNumber - Betrifft: $in{'AdSubject'} - Geschaltet am: $shortdate\n";
	print MAIL "Antwort an: $in{'RealName'} unter <a href=\"mailto:$in{'EMailAddress'}\">$in{'EMailAddress'}</a>\n";
	print MAIL "$in{'Description'}\n";
	print MAIL "Homepage: <A href=\"$in{'Linkurl'}\">$in{'Linktitle'}</a>\n\n";
	print MAIL "Der Webmaster\n";
	close(MAIL);

	#Benachrichtigung an den Webmaster
	if( $return_name ne "" )
	{
		open( MAIL, "|$mailprog $return_name" ) || die "Kann Sendmail fuer Benachrichtigung nicht oeffnen: $return_name: $!\n";
		print MAIL "To: $return_name\n";
		print MAIL "Subject:Benachrichtigung bzgl. Kleinanzeige\n";
		print MAIL "From: $in{ 'RealName' } <$in{ 'E-MailAddress' }>\n\n";
		print MAIL "Neuer Kleinanzeigeneintrag in der Kategorie \"$in{'Department'}\":\n\n";

		print MAIL "Anz.-Nr.: $AdNumber - Betrifft: $in{'AdSubject'} - am: $shortdate<br>\n";
		print MAIL "Antwort an: $in{'RealName'} unter <a href=\"mailto:$in{'EMailAddress'}\">$in{'EMailAddress'}</a><br>\n";
		print MAIL "$in{'Description'}\n";
		print MAIL "<A href=\"$in{'Linkurl'}\">$in{'Linktitle'}</a>";
	}
	
	# Der Besucher wird an die die Verweis-URL geschickt.
	print "<meta http-equiv=\"refresh\" content=\"1; url=$in{'ReturnURL'}\">\n";
	$quit = 1;
	close(MAIL);
}
